<?php
/**
 * 更新操作
 * 操作人: gyq_10
 * 日期: 2016/4/13
 * 时间: 13:18
 * 说明:新增单据分录自定义类文件
 */
class cls_ProductToolFields {
    private $tableid;
    protected $theme_path;
    protected $image_path;
    public $producttoolhtml;
    public $formualFields;


    public function __construct($tableid)
    {
        $this->tableid = $tableid;
        global $theme,$current_user;
        $theme_path="themes/".$theme."/";
        $image_path=$theme_path."images/";
        $this->theme_path = $theme_path;
        $this->image_path = $image_path;
    }

    /* Explain:新增获取自定义字段权限，原方法getProductProfile为静态方法，舍弃不用 */
    public function getProductProfile_tab($producttoolfieldid,$tabid){
        global $adb;
        $cachekey = 'getProductProfile_'.$producttoolfieldid.'_'.$tabid;
        $productprofile = Cache($cachekey);
        if(!$productprofile){

            $query = 'select userid,profilefieldtype from ld_producttoolprofile where producttoolfieldid = ? and tabid= ?
            and profilefieldtype="user" 
            union all select ld_users.id as userid ,"user" as profilefieldtype  from ld_producttoolprofile
            inner join ld_profile  on ld_producttoolprofile.userid=ld_profile.profileid
            inner join ld_users on ld_users.profileid=ld_profile.profileid
            where producttoolfieldid = ? and tabid= ? and profilefieldtype="role"
			union all select ld_users2group.userid as userid ,"user" as profilefieldtype  from ld_producttoolprofile
			inner join ld_groups  on ld_producttoolprofile.userid=ld_groups.groupid
			inner join ld_users2group on ld_users2group.groupid=ld_groups.groupid
			where producttoolfieldid = ? and tabid= ? and profilefieldtype="group"
            ';
            $result = $adb->pquery($query,array($producttoolfieldid,$tabid,$producttoolfieldid,$tabid,$producttoolfieldid,$tabid));
            $num_rows = $adb->num_rows($result);
            $productprofile = Array();
            for($i = 0; $i<$num_rows; $i++){
                $userall[$i] = $adb->query_result($result,$i,'userid');
            }
            $productprofile[$tabid][$producttoolfieldid] = $userall;
            Cache($cachekey,$productprofile);
        }

        return $productprofile[$tabid][$producttoolfieldid];
    }
	
	//获取分录对应权限表的值   用户分配使用
	public function getProductProfile_Allocate($producttoolfieldid,$tabid){
		global $adb;
		$query = "select profilefieldtype,GROUP_CONCAT(userid) from ld_producttoolprofile where producttoolfieldid = ? and tabid= ? GROUP BY profilefieldtype";
		$result = $adb->pquery($query,array($producttoolfieldid,$tabid));
		$num_rows = $adb->num_rows($result);
		if($num_rows >= 1){
			$profilefieldtype = $adb->query_result($result,0,'profilefieldtype');
			if(empty($profilefieldtype)){
				$profilefieldtype = 'all';
			}
			$data = array('profilefieldtype'=>$profilefieldtype,'userids'=>$adb->query_result($result,0,1));
		}else{
			$data = array('profilefieldtype'=> 'all','userids'=>0);
		}
		return $data;
	}

    public function getFieldList($type){
        global $adb,$languageType;
        if($_REQUEST['type'] == 'Sort'){
            $presence = "and ld_producttoolfield.presence in (0,2,3)";
        }else{
            $presence = "and ld_producttoolfield.presence = 1";
        }
        $query="select producttoolfieldid,ld_tranlabel.fieldlabel
                    from ld_producttoolfield
                      LEFT JOIN ld_tranlabel
                        on ld_tranlabel.relateid = ld_producttoolfield.producttoolfieldid
                    where ld_producttoolfield.tabid = ? and ld_tranlabel.trantable = ?  $presence and ld_tranlabel.languagetype=?
                    GROUP BY ld_producttoolfield.producttoolfieldid order by ld_producttoolfield.sequence asc";
        $result=$adb->pquery($query,array($_REQUEST['tabid'],'ld_producttoolfield',$languageType));
        while ($fieldrow = $adb->fetch_array($result)) {
            $fieldlist[$fieldrow['producttoolfieldid']]=$fieldrow['fieldlabel'];
        }
        return $fieldlist;
    }
    /* Explain:获取单据分录自定义序时簿界面内容 */
    public function getDetailInfo(){

        global $adb;

        $query = "	select producttoolfieldid,width,presence,columnname,typeofdata,uitype,allowhide,input_type,bigtype,savedatabase,defaultcolumn,
		GROUP_CONCAT(ld_tranlabel.fieldlabel order by ld_tranlabel.languagetype desc SEPARATOR '||') as fieldlabel,sequence,edit_permission from ld_producttoolfield
	LEFT JOIN ld_tranlabel
		on ld_tranlabel.relateid = ld_producttoolfield.producttoolfieldid
	where ld_producttoolfield.tabid = ? and ld_tranlabel.trantable = ?  and ld_producttoolfield.presence in (0,2)
	 GROUP BY ld_producttoolfield.producttoolfieldid order by ld_producttoolfield.sequence asc";
        $result=$adb->pquery($query,array($this->tableid,'ld_producttoolfield'));
        $num_rows = $adb->num_rows($result);


        $producttoolhtml='';
        $selectmodule = getTabModuleName($this->tableid);//当前选中的模块名
        $formualFields[]=array('columnname'=>'none','fieldlabel'=>'');
        for($i=0;$i<$num_rows;$i++)
        {

            $producttoolfieldid=$adb->query_result($result,$i,'producttoolfieldid');

            $presence=$adb->query_result($result,$i,'presence');//是否启用
            $width=$adb->query_result($result,$i,'width');//列宽
            $sequence=$adb->query_result($result,$i,'sequence');//显示顺序
            $fieldlabel=explode('||',$adb->query_result($result,$i,'fieldlabel'));//中英文翻译，用"｜｜"分割
            $defaultcolumn=$adb->query_result($result,$i,'defaultcolumn');//是否为系统预置字段0:预置,1:非预置字段
            $edit_permission = $adb->query_result($result,$i,'edit_permission');//是否允许编辑
            $typeofdata = $adb->query_result($result,$i,'typeofdata');
            $uitype = $adb->query_result($result,$i,'uitype');
            $fieldvaluecolor = $adb->query_result($result,$i,'fieldvaluecolor');//zxm20211230 字段颜色字段说明
            $fieldplaceholder = $adb->query_result($result,$i,'fieldplaceholder');
            $allowhide = $adb->query_result($result,$i,'allowhide');//字段是否允许隐藏
            $input_type = $adb->query_result($result,$i,'input_type');//输入类型
            $bigtype = $adb->query_result($result,$i,'bigtype');//字段类型
            $savedatabase = $adb->query_result($result,$i,'savedatabase');
            $typedata = explode('~',$typeofdata);
            
            //$productprofile = $this->getProductProfile_tab($producttoolfieldid,$this->tableid);//自定义字段权限
			$productprofile = $this->getProductProfile_Allocate($producttoolfieldid,$this->tableid);
            //是否启用
            //edit:duan 2022-2-18 是否选项修改为按钮
            $image = '<input type="checkbox" onclick="change_tablefield_presence(this,'.$producttoolfieldid.',\'producttoolfield_presence\')" class="second_switch" ';            
            if($presence == 0 || $presence == 2){     
                $image .= ' checked ';
            }
            if($allowhide == 'no'){
                $image .= ' disabled ';
            }
            $image .= ' />';
            
            //是否需要编辑
            //edit:duan 2022-2-18 是否选项修改为按钮
            $defaultcolumn_edit = array('2','3','4','6','7');
            $editimage = '<input type="checkbox" onclick="change_tablefield_presence(this,'.$producttoolfieldid.',\'producttoolfield_edit_permission\')" class="second_switch" ';
            if($edit_permission ==0){
                $editimage .= ' checked ';
            }
            //控制某些预置字段不可取消编辑
            if(in_array($defaultcolumn,$defaultcolumn_edit) || $input_type==1 || ($bigtype=='relatedmodulefield'&&$savedatabase=='no')||($bigtype=='reference')||$bigtype=='multipicklist'){
                $editimage .= ' disabled ';
            }
            $editimage .= ' />';
            
            //是否必填
            //edit:duan 2022-2-18 是否选项修改为按钮
            $defaultcolumn_mandatory = array('2','3','4');
            $typedataImage = '<input type="checkbox" onclick="change_tablefield_presence(this,'.$producttoolfieldid.',\'producttoolfield_mandatory\')" class="second_switch" ';
            if($typedata[1] == 'M'){
                $typedataImage .= ' checked ';
            }
            //控制某些预置字段不可取消必填
            if($defaultcolumn==5&&$allowhide == 'no'){
                $typedataImage .= ' disabled ';
            }else if(in_array($defaultcolumn,$defaultcolumn_mandatory) || ($input_type==1&&$typedata[1] == 'M') || ($bigtype=='relatedmodulefield'&&$savedatabase=='no')){
                $typedataImage .= ' disabled ';
            }
            $typedataImage .= ' />';
            
            if ($i%2 ==0) {
                $producttoolhtml.='<tr id="setting_'.$i.'" class="lvtColData" onmouseover="settingListOnMouseOver('.$i.')" onmouseout="settingListOnMouseOut('.$i.',\'on\')" >';
            }
            else{
                $producttoolhtml.='<tr id="setting_'.$i.'" class="lvtColDataBj" onmouseover="settingListOnMouseOver('.$i.')" onmouseout="settingListOnMouseOut('.$i.',\'On\')" >';
            }
            $producttoolhtml.='<td>'.($i+1).'<input type="hidden" name="producttoolfield'.$producttoolfieldid.'" value="'.$producttoolfieldid.'"/></td>';
            $producttoolhtml.='<td><span title="'.$fieldlabel[0].'">'.$fieldlabel[0].'</span></td> ';
            $producttoolhtml.='<td><span title="'.$fieldlabel[1].'">'.$fieldlabel[1].'</span></td> ';
            $producttoolhtml.='<td><span title="'.$width.'">'.$width.'</span></td> ';
            $producttoolhtml.='<td>'.$image.'</td> ';
            $producttoolhtml.='<td>'.$typedataImage.'</td> ';
            $producttoolhtml.='<td>'.$editimage.'</td> ';
            if($producttoolfieldid == 28){
                /* echo $producttoolhtml;*/
            }
			$columname=$adb->query_result($result,$i,'columnname');  
            //编辑
            $producttoolhtml .= '<td><a class="Anu3_a" onclick="ProductToolEditField(this,\'dvProductToolEditField\','.$producttoolfieldid.','.$this->tableid.')">'.getFixedLabel('EDIT').'</a>';
			if($columname != 'productname'){
				$producttoolhtml .= '<a class="Anu3_a" btn="editBtn" record="'.$producttoolfieldid.'" onclick="ScopePopup_Details.getInstance().allocateTemplate(this,\''.$this->tableid.'\',\''.$producttoolfieldid.'\',\''.$productprofile['userids'].'\',\''.$productprofile['profilefieldtype'].'\',\'ProductToolField\');">'.getFixedLabel('ALLOCATE').'</a>';	//分配	
			}
            /* editor:gyq_08 reason:分录排序自定义限定产品名称不可限制权限 date:2016 3 14 */
                      
            $producttoolhtml .='</td>';
            $typeofdata=$adb->query_result($result,$i,'typeofdata');
            $typeofdatas=explode('~',$typeofdata);
            if((strtolower($typeofdatas[0])=='n'||strtolower($typeofdatas[0])=='nn'||$uitype==99)&& $uitype != 33 && $uitype != 35 && $uitype !=36 && $uitype != 37)
            {
                if($presence == 0 || $presence == 2)
                {
                    global $languageType;
                    if($languageType=='zh')
                        $formualFields[]=array('columnname'=>$columname,'fieldlabel'=>$fieldlabel[0]);
                    else
                        $formualFields[]=array('columnname'=>$columname,'fieldlabel'=>$fieldlabel[1]);
                }
            }
        }
        $this->formualFields = $formualFields;
        $this->producttoolhtml = $producttoolhtml;
        $this->columname=$columname;

    }

    /**
     * V6.1 单据分录自定义 :更改产品自定义显示列顺序
     * @param 新增、编辑产品自定义信息
     * @author Chj 2015/5/28
     */


    public function SaveProductToolField($productModule) {
        global $adb;
       // $productModule=new $productModule();
		
        $tableName=$focus->Detail_table_scf;
        $tabid = vtlib_purify($_REQUEST['tabid']);//选中的模块ID
        $zh_fieldlabel=vtlib_purify(trim($_REQUEST['zh_fieldlabel']));//中文标签
        $en_fieldlabel=vtlib_purify(trim($_REQUEST['en_fieldlabel']));//英文标签
        $width= vtlib_purify($_REQUEST['width']);//宽度
        $ismandatory=vtlib_purify($_REQUEST['ismandatory']);//必填字段
        $ispresence=vtlib_purify($_REQUEST['ispresence']);//是否显示
        $isedit=vtlib_purify($_REQUEST['isedit']);//允许编辑
        $fldlength=vtlib_purify($_REQUEST['textlength']);//字段长度
        $defaultvalue = vtlib_purify($_REQUEST['defaultvalue']);//默认值
        $selectFieldType = vtlib_purify($_REQUEST['selectFieldType']);//文本类型
        $producttoolfieldid = vtlib_purify($_REQUEST['producttoolfieldid']);//自定义字段ID
        
        $inputModeType = vtlib_purify($_REQUEST['inputModeType']);//录入方式
        $fieldid = vtlib_purify($_REQUEST['attributeField']);//属性字段fieldid
        $uitype = vtlib_purify($_REQUEST['uitype']);
		$fldPickList = vtlib_purify($_REQUEST['fldPickList']);//下拉框、多选框值
		$referencemodule = vtlib_purify($_REQUEST['referencemodule']);//可选择的数据范围
		$datarange = vtlib_purify($_REQUEST['datarange']);//可选择的数据范围
		$approve_demand = vtlib_purify($_REQUEST['approve_demand']);//审批要求
		//审批要求  其他设置
		$column_highsearch_info_json = '';
		if(!empty($referencemodule) && !empty(vtlib_purify($_REQUEST['advft_criteria'])) && !empty(vtlib_purify($_REQUEST['advft_criteria_groups']))){
			$effectivecondition['reference']['advft_criteria'] = $_REQUEST['advft_criteria'];
			$effectivecondition['reference']['advft_criteria_groups'] = $_REQUEST['advft_criteria_groups'];
		}
		if(sizeof($effectivecondition)>0){
			$column_highsearch_info_json = json_encode($effectivecondition);
		}
		$maxrowsshow = vtlib_purify($_REQUEST['maxrowsshow']);//最多显示数据条数
		$savedatabase = $_REQUEST['savedatabase'];
		$fieldplaceholder = $_REQUEST['fieldplaceholder'];//zxm
		$fieldvaluecolor = $_REQUEST['fieldvaluecolor'];
        $cur_module = getTabname($tabid);
        $cur_focus=CRMEntity::getInstance($cur_module);
        //$sql='select * from ld_productoolfield'
        if(empty($fieldid))
        {
            $fieldid=0;
        }
        //duan 2022-4-21 部分客户的数据库中int类型的字段不允许设为空值
        if(empty($maxrowsshow)){
            $maxrowsshow = 0;
        }
        $precision = vtlib_purify($_REQUEST['precision']);//精度
        if(empty($precision))
        {
			if($selectFieldType == 20)
				$precision=2;
			else
				$precision=6;
        }
        if(get_magic_quotes_gpc() == 1) {
            $zh_fieldlabel = stripslashes($zh_fieldlabel);
			$en_fieldlabel = stripslashes($en_fieldlabel);
        }
        //判断自定义字段是否已经存在
        $checkquery="select 1 from ld_tranlabel where trantable = 'ld_producttoolfield' and fieldlabel=? and tabid=?";
        if(!empty($producttoolfieldid)){
            $checkquery_zh = $checkquery . " and relateid != " . $producttoolfieldid;
			$checkquery_en = $checkquery . " and relateid != " . $producttoolfieldid;
        }else{
			$checkquery_zh = $checkquery_en = $checkquery;
		}
       
        $checkresult_zh=$adb->pquery($checkquery_zh,array($zh_fieldlabel,$tabid));
		$checkresult_en=$adb->pquery($checkquery_en,array($en_fieldlabel,$tabid));
        if($adb->num_rows($checkresult_zh) > 0) {
            $duplicate = 'zhyes';//Liver 2016/07/22 表示中文重复
            return $duplicate ;
        }elseif($adb->num_rows($checkresult_en) > 0){
            $duplicate = 'enyes'; //Liver 2016/07/22 表示英文重复
            return $duplicate ;
        }else {
			$before_selectFieldType = $selectFieldType;
			if($selectFieldType == 101){
				if(!empty($_REQUEST['related_module']) && !empty($_REQUEST['related_module_field'])){
					$fieldobj=Field::getInstance($_REQUEST['related_module'],$adb);
					$modulefields = $fieldobj->getModuleFields();
					$field = $modulefields[$_REQUEST['related_module_field']];
					if(!empty($field)){
						$fieldDataType = $field->getFieldDataType();
                        $parentbigtype=$field->getBigType();
						$_REQUEST['related_module_field'] = $field->getColumnName();
						if($fieldDataType == 'datetime'){
							$selectFieldType = 52;
						}else if($fieldDataType == 'double'){
							$selectFieldType = 20;
						}else if($fieldDataType == 'boolean'){
							$selectFieldType = 56;
						}else if($fieldDataType == 'currency'){
							$selectFieldType = 50;
						}else if($fieldDataType == 'date'){
							$selectFieldType = 51;
						}else if($fieldDataType == 'time'){
							$selectFieldType = 53;
						}else{
							$field_uitype = $field->getUIType();
							if(in_array($field_uitype,array(21,33,154))){
								$selectFieldType = 2;
							}
                            else if($field->getBigType()=='reference'){
                                $selectFieldType = 100;
                            }else{
								$selectFieldType = 1;
							}
						}
					}
				}
                if(!empty($_REQUEST['related_optionmodule_field_bigtype'])){
                    $parentbigtype = $_REQUEST['related_optionmodule_field_bigtype'];
                    if($parentbigtype == 'datetime'){
						$selectFieldType = 52;
					}else if($parentbigtype == 'number'){
						$selectFieldType = 20;
					}else if($parentbigtype == 'boolean'){
						$selectFieldType = 56;
					}else if($parentbigtype == 'currency'){
						$selectFieldType = 50;
					}else if($parentbigtype == 'date'){
						$selectFieldType = 51;
					}else if($parentbigtype == 'time'){
						$selectFieldType = 53;
					}else if($parentbigtype == 'reference'){//引用关联选择单据
					   $selectFieldType = 100;
					}else if($parentbigtype == 'selectsource'){//引用源单
					   $selectFieldType = 220;
					}else{
						$selectFieldType = 1;
					}                    
                }
                //edit;can 0046355: （https://81mis.com/kfbcrm [^]）客户问题（刘傲），合同订单（合同编号：SO17）单据分录增加字段公式：金额1+金额2=金额合计，“金额合计”字段设置“不允许编辑”时，单据查看详0046355: （https://81mis.com/kfbcrm [^]）客户问题（刘傲），合同订单（合同编号：SO17）单据分录增加字段公式：金额1+金额2=金额合计，“金额合计”字段设置“不允许编辑”时，单据查看详
               /*	if($isedit == 1){
					$savedatabase = 'no';
				}else{
					$savedatabase = 'yes';	//chj 2021/4/21 45581: 带产品分录的模块(采购订单)->单据分录定制，新增日期类型字段，savedatabase 保存为null
				}*/
			}else{
			
			}
            //文本类型
            if($selectFieldType == 1 || $selectFieldType == 2){
                if($ismandatory == 0){
                    $uichekdata='V~M~'.$fldlength;
                }else{
                    $uichekdata='V~O~'.$fldlength;
                }
            }else if($selectFieldType == 24){//整数长度默认为int11
                if($ismandatory == 0){
                    $uichekdata='NN~M';
                }else{
                    $uichekdata='NN~O';
                }
            }else if($selectFieldType == 20 || $selectFieldType == 10 || $selectFieldType == 50|| $selectFieldType == 163){//数字、数量、金额、单价
                $data_precision = '';
				if(empty($precision))$precision = 0;
				if($selectFieldType==10){
					$sysdeploy = getSys_deploy(49);
					$precision = $sysdeploy['deploy_value'];
				}else if($selectFieldType==163){
					$sysdeploy = getSys_deploy(93);
					$precision = $sysdeploy['deploy_value'];
				}
				$data_precision = '25,'.$precision;
				
                /*if($precision >= 0){
                    if($selectFieldType==163){
                        $precision = 8;
                        $data_precision = '25,'.$precision;
                    }else{
                        $data_precision = '25,'.$precision;
                    }

                }*/
                if($ismandatory == 0){
                    $uichekdata='N~M~'.$data_precision;
                }else{
                    $uichekdata='N~O~'.$data_precision;
                }
            }else if($selectFieldType >= 51 && $selectFieldType <= 54){//时间、日期
                if(!empty($_REQUEST['dataOption'])){
                    $defaultvalue = $_REQUEST['dataOption'];
                }
            }else if($selectFieldType == 56){
                $defaultvalue = $_REQUEST['checkcolumn'];
                $uichekdata = 'V~O';
            }
			
			$bigtype = 'text';
            switch($selectFieldType){
                case '1':
					//zkt BUG0055684合同订单列表，将产品分录定制中的自定义“引用客户电话”字段显示在列表界面后，合同订单列表界面数据显示不出来 
                    if(empty($fldlength)){
                        $fldlength = 100;
                    }
                    $type = "C(".$fldlength.") default ()";
					$bigtype = 'text';
                    break;
                case '2':
                    $type = 'text';
					$bigtype = 'textarea';
                    break;
                case '24':
                    $type = "I(11) default 0";
					$bigtype = 'int';
                    break;
                case '20':
                    $type="N(25.8)";//$precision
					$bigtype = 'number';
                    break;
                case '10':
                    $type="N(25.8)";
					$bigtype = 'num';
                    break;
                case '50':
                    $type="N(25.8)";
					$bigtype = 'amount';
                    break;
                case '163':
                    $type="N(25.8)";
					$bigtype = 'price';
                    break;
                case '51':
                    $type = 'date';
                    if($ismandatory == 0)
                        $uichekdata='D~M';
                    else
                        $uichekdata='D~O~';
					$bigtype = 'date';
                    break;
                case '52':
                    $type = 'datetime';
                    if($ismandatory == 0)
                        $uichekdata='DT~M';
                    else
                        $uichekdata='DT~O~';
					$bigtype = 'datetime';
                    break;
                case '53':
                    $type = 'time';
                    if($ismandatory == 0)
                        $uichekdata='T~M';
                    else
                        $uichekdata='T~O~';
					$bigtype = 'time';
                    break;
                case '54':
                    $type = 'time';
                    if($ismandatory == 0)
                        $uichekdata='T~M';
                    else
                        $uichekdata='T~O~';
					$bigtype = 'time';
                    break;
                case '56':
                    $type = "I(3) default 0";
					$bigtype = 'boolean';
                    break;
				case '60':
					$bigtype = 'picklist';
					if($ismandatory == 0)
						$uichekdata='V~M';
					else
						$uichekdata='V~O';
                    //zkt 20220621 BUG0053061页面设置/单据分录定制，添加的下拉框和文本字段默认长度改为100,不要给255
				    $type = 'C(100)';
				    break;
				case '63':
					if($ismandatory == 0)
						$uichekdata='V~M';
					else
						$uichekdata='V~O';
				   $type = 'text';
				   $bigtype = 'multipicklist';
				   break;
				case '100':
					if($ismandatory == 0)
						$uichekdata='V~M';
					else
						$uichekdata='V~O';
					$bigtype = 'reference';
					$type = "int";
					break;
                case '69':
                    if($ismandatory == 0)
                        $uichekdata='V~M';
                    else
                        $uichekdata='V~O';
                    $bigtype = 'image';
                    $type = "C(5) default ()";
                    $savedatabase = 'no';//图片字段为no，且无需新增字段到自定义表
                    break;
                case '220'://引用表体源单字段
                    if($ismandatory == 0)
                        $uichekdata='V~M';
                    else
                        $uichekdata='V~O';
                    //$bigtype = 'selectsource';
                    $type = "int";
                    break;
            }
			if($before_selectFieldType == 101){
				$bigtype = 'relatedmodulefield';
                if(empty($type)){
				    $type = "text";
                }
			}
			
            if(($inputModeType==0 ||$inputModeType==2)&&!empty($producttoolfieldid))
            {
                $sql='select columnname,tablename,defaultcolumn from ld_producttoolfield  where producttoolfieldid=?';
                $result=$adb->pquery($sql,array($producttoolfieldid));
                $tableName=$adb->query_result($result,0,'tablename');
                $columnName=$adb->query_result($result,0,'columnname');
                $defaultcolumn=$adb->query_result($result,0,'defaultcolumn');
            }

            //录入方式
           
            if($inputModeType == 2){//公式
                $formulastring=$_REQUEST['formulacontent'];
                $formulavar=$_REQUEST['formulavar'];
                $formulacolumn=$_REQUEST['formulacolumn'];
                $vars=array_filter(explode(',',$formulavar));
                $columns=array_filter(explode(',',$formulacolumn));

                $columnstring="{formulavar:[";
                for($i=0;$i<sizeof($vars);$i++)
                {
                    $columnstring.="{'lettervar':'".$vars[$i]."','column':'".$columns[$i]."'}";
                    if($i!=sizeof($vars)-1)
                    {
                        $columnstring.=",";
                    }
                }
                $columnstring.=']}';
                  //edit:can 20220301 50181: （无外网）（客户问题-徐东）渠道管理-经销商年度目标模块，新建单据保存后，分录第2季度、第3季度、第4季度目标额变空了
                //有字段公式的字段 设置不允许编辑 应该是savedatabase='yes'
                $savedatabase='yes';
            }
            else if($inputModeType == 1 && $uitype != 25)
            {
                $fieldobj=Field::getInstance('Products',$adb);
                $profieldarr=$fieldobj->FieldInfoListByKeyValue('fieldid',$fieldid);
                $tableName=$profieldarr['tablename'];
                $columnName=$profieldarr['columnname'];
            
                $selectFieldType=$profieldarr['uitype'];
                $isedit=2;
                $defaultvalue = '';
				$savedatabase = 'no';
            }
			$fieldobj=Field::getInstance('Products',$adb);
          
            if(empty($producttoolfieldid)){//新增
                $adb->pquery('update ld_producttoolfield_seq set id=(select max(producttoolfieldid) from ld_producttoolfield)');
                $max_fieldid = $adb->getUniqueID("ld_producttoolfield");//获取产品自定义表的最大键值
                $producttoolfieldid = $max_fieldid;
                $max_fieldsequence = "select max(sequence)+1 as maxsequence from ld_producttoolfield ";
                $res = $adb->pquery($max_fieldsequence,array());
                $max_seq = $adb->query_result($res,0,'maxsequence');
                $max_tranlabel = 'select max(tranlabelid)+1 as max_tranlabelid from ld_tranlabel';
                $res = $adb->pquery($max_tranlabel,array());
                $max_tranlabelid = $adb->query_result($res,0,'max_tranlabelid');
                $cnt=0;
                $tmptablename='';
                $tmpcolumnname='';
                
                foreach($productModule as $key => $moduleInfo){
                    $tmp_tabids=array_keys($moduleInfo);
                    $tmp_modulename=getTabModuleName($tmp_tabids[0]);
                
					//关联选择单据、单选
                    if($selectFieldType == 100 || $bigtype == 'relatedmodulefield'){
						if($tmp_modulename != $cur_module){
							continue;
						}
					}
                    if(get_file_address($tmp_modulename,$tmp_modulename.'DetailFieldsHtml') )
                    {
                        
                         continue;
                    }
                    if($inputModeType!=1){
						$columnName = 'sf'.($max_fieldid+1);
						if($selectFieldType == 100&&$before_selectFieldType!=101){
							$columnName = 'line'.'_'.strtolower($_REQUEST['referencemodule']) . '_id';
						}
					}
                        
                     
					//如果选择的是已有基础属性，字段类型默认为文件
                 
					if($inputModeType == 1){
						$uitype=$fieldobj->getFieldInfoBykeyValue('columnname',$columnName,'uitype');
						$typeofdata=$fieldobj->getFieldInfoBykeyValue('columnname',$columnName,'typeofdata');
                      
                        $tableName=$fieldobj->getFieldInfoBykeyValue('columnname',$columnName,'tablename');
						$field_datas = explode('~',$typeofdata);
                      
						$selectFieldType = $uitype;
                        
						//$selectFieldType = $this->getProductForToolFieldUitype($uitype,$typeofdata);
						/*if($selectFieldType != 69){
							$selectFieldType = 1;
						}*/
                       
    						if($ismandatory == 0)
                           {
                            //37757: （1.6）合同订单新增界面>产品区块>【取值数字 】字段：该字段是自定义数字类型字段，设置的小数位数是三位，但是只显示一位。（需要补丁）
                                 if(sizeof($field_datas)==3)
        						{
        						  $uichekdata = $field_datas[0] . '~M~'.$field_datas[2];
        						}
                                else
                                {
                                    $uichekdata = $field_datas[0] . '~M';
                                }
                           }
					       	else
        			 		{
        			 		      if(sizeof($field_datas)==3)
            						{
            						  $uichekdata = $field_datas[0] . '~O~'.$field_datas[2];
            						}
                                    else
                                    {
                                        $uichekdata = $field_datas[0] . '~O';
                                    }
        			 		}
                           
					}
                  
                    
                    foreach($moduleInfo as $moduleid => $modulename){
						$module=getTabModuleName($moduleid);
                        $focus=CRMEntity::getInstance($module);
						if($inputModeType == 1){
							$tableName=$fieldobj->getFieldInfoBykeyValue('columnname',$columnName,'tablename');
						}
						else
							$tableName=$focus->Detail_table_scf;
                        if($selectFieldType == 100){
							$tableName = $focus->Detail_table;
						}
						if(get_file_address($module,$module.'DetailFieldsHtml')){
							continue;
						}
                        $query = "insert into ld_producttoolfield (producttoolfieldid,columnname,fieldlabel,defaultvalue,presence,uitype,typeofdata,sequence,tabid,tablename,width,edit_permission,input_type,fieldid,defaultcolumn,referencemodule,datarange,approve_demand,maxrowsshow,bigtype,savedatabase,fieldplaceholder,fieldvaluecolor,effectivecondition)
					values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
                        if($moduleid == $tabid){
                            $presence = $ispresence;
                        }else{
                            $presence = 1;
                        }$adb->pquery($query,array($producttoolfieldid+$key,$columnName,$zh_fieldlabel,$defaultvalue,$presence,$selectFieldType,$uichekdata,$max_seq+$key,$moduleid,$tableName,$width,$isedit,$inputModeType,$fieldid,1,$referencemodule,$datarange,$approve_demand,$maxrowsshow,$bigtype,$savedatabase,$fieldplaceholder,$fieldvaluecolor,$column_highsearch_info_json));
                        if($before_selectFieldType == 101){
                            $sql='update ld_producttoolfield set parentbigtype=? where producttoolfieldid=?';
                            $adb->pquery($sql,array($parentbigtype,$producttoolfieldid+$key));
                        }

                    }
					//引用字段
					if($before_selectFieldType == 101){
					   //zkt 20220623 1000143  采购订单、收付款单、出入库单，分录明细增加“合同订单”字段（咏睿）
					   //源单
    					if(!empty($_REQUEST['related_optionmodule_field'])){
    						$fromvalue_infos = array();
    						$related_optionmodule_fields = ldcrm_json_decode($_REQUEST['related_optionmodule_field']);
    						foreach($related_optionmodule_fields as $optionmodule => $optionmodule_column){
    							$fromvalue_infos[] = array('module'=>$optionmodule,'column'=>$optionmodule_column['columnname'],'columntype'=>$optionmodule_column['columntype']);
    						}
    						$query = "insert into ld_related_detailfield(modulename,trigger_columnname,effect_columnname,curmodule_columninfo,fromvalue_type,fromvalue_info,frommodule) values (?,?,?,?,?,?,?)";
    						$adb->pquery($query,array($cur_module,$_REQUEST['related_module_column'],$columnName,$columnName,'selectsource',ldcrm_json_encode($fromvalue_infos),''));
    					}else{
    					   $query = "insert into ld_related_detailfield(modulename,trigger_columnname,effect_columnname,curmodule_columninfo,fromvalue_type,fromvalue_info,frommodule) values (?,?,?,?,?,?,?)";
						  $adb->pquery($query,array($cur_module,$_REQUEST['related_module_column'],$columnName,$columnName,'column',$_REQUEST['related_module_field'],$_REQUEST['related_module']));   
    					}
                        
                        
					}
					//分录字段  -  适用范围
					if($_REQUEST['profile_field_type'] != 0){
						$profile_field_type = $_REQUEST['profile_field_type'];
						$profile_field_value = '';
                        $profilefieldtype='';
						if($profile_field_type == 1){
							$profile_field_value = $_REQUEST['profile_field_value'];
                            $profilefieldtype='user';
						}
                        else if($profile_field_type==3)
                        {
                            //edit:can 20200825 按角色
                            $profile_field_value = $_REQUEST['profile_field_value'];
                            $profilefieldtype='role';
                        }
						else if($profile_field_type==2)
                        {
                            //按部门
                            $profile_field_value = $_REQUEST['profile_field_value'];
                            $profilefieldtype='group';
                        }
						if($_REQUEST['profile_field_type'] != 0){
							
							$this->UpdateProductProfile($cur_module,$producttoolfieldid+$key,$profile_field_value,$profilefieldtype);
						}
					}
                   $sqls = "insert into ld_tranlabel (tranlabelid,languagetype,trantable,tabid,relateid,fieldlabel) values(?,?,?,?,?,?)";
                   $qparam = array($max_tranlabelid+$cnt,'zh','ld_producttoolfield',$moduleid,$producttoolfieldid+$key,$zh_fieldlabel);
                   $qparamz = array($max_tranlabelid+$cnt+1,'en','ld_producttoolfield',$moduleid,$producttoolfieldid+$key,$en_fieldlabel);
                    $adb->pquery($sqls, $qparam);
                    $adb->pquery($sqls, $qparamz);
                    
                    if($inputModeType == 2){
                        $sql='select max(sequence) from  ld_producttoolfield_formula  where producttoolfieldid in(select producttoolfieldid from ld_producttoolfield where tabid=?) ';
                        $max_result_sequence=$adb->pquery($sql,array($tabid));
                        if($adb->num_rows($max_result_sequence)>0)
                            $max_sequence=$adb->query_result($max_result_sequence,0,0)+1;
                        else
                            $max_sequence=1;
                        $sql=' insert ld_producttoolfield_formula(formulastring,columnstring,producttoolfieldid,sequence)value(?,?,?,?)';

                        $param=array($formulastring,$columnstring,$producttoolfieldid+$key,$max_sequence);

                        $adb->pquery($sql,$param);
                    }
                    $cnt+=2;
                    if ($bigtype != 'image')
                         $adb->alterTable($tableName, $columnName." ".$type, "Add_Column");
                    
                    if($tmp_modulename==$cur_module)
                    {
                        $tmptablename=$tableName;
                        $tmpcolumnname=$columnName;
                    }
                }
                $tableName=$tmptablename;
                $columnName=$tmpcolumnname;
            
                $query='update ld_producttoolfield_seq set id = (select max(producttoolfieldid) from ld_producttoolfield)';
                $adb->pquery($query,array());
				if($selectFieldType == 60 || $selectFieldType == 63){
					$objPickList = crm_load_class_obj("cls_PickList",'modules/PickList',array());
					$objPickList->addPickField($fldPickList,$columnName,'ld_producttoolfield');
				}
            }
            else{//编辑
				
				//如果选择的是已有基础属性，字段类型默认为文件
                
				if($inputModeType == 1){
					$uitype=$fieldobj->getFieldInfoBykeyValue('columnname',$columnName,'uitype');
					$typeofdata=$fieldobj->getFieldInfoBykeyValue('columnname',$columnName,'typeofdata');
					$field_datas = explode('~',$typeofdata);
                    $tableName=$fieldobj->getFieldInfoBykeyValue('columnname',$columnName,'tablename');
					$selectFieldType = $uitype;
                    $fieldid=$fieldobj->getFieldInfoBykeyValue('columnname',$columnName,'fieldid');
                 
					//$selectFieldType = $this->getProductForToolFieldUitype($uitype,$typeofdata);
					/*if($selectFieldType != 69){
						$selectFieldType = 1;
					}*/
                  if($inputModeType == 1){
					   if($ismandatory == 0)
                            $uichekdata = $field_datas[0] . '~M';
                        else
                            $uichekdata = $field_datas[0] . '~O';
                        //date:2021-9-3 edit:duan reason:产品分录中关联字段时的字段长度无法保存 
                        if($fldlength != ""){
                            $uichekdata.="~".$fldlength;
                        }else{
                            if(stripos($typeofdata,"N")!==false){
                            	$fldlength=25;
                            }else{
                            	$fldlength=$field_datas[2];
                            }
                            if($fldlength>0){
                                $uichekdata.="~".$fldlength;
                            }
                        }
                        if(stripos($typeofdata,"N")!==false)
                        {
                            //37769: 单据分录定制->字段关联产品字段并且是3位小数，编辑的时候 typeofdata 变成NN~O~了
                            $uichekdata.=','.$_REQUEST['precision'];
                        }
					}
				}
                
				$query = 'select edit_permission,tablename,columnname from ld_producttoolfield where producttoolfieldid = ?';
				$result = $adb->pquery($query,array($producttoolfieldid));
				$edit_permission = $adb->query_result($result,0,0);
                if(empty($fieldid))
                {
                    //选择产品的字段在编辑的情况下，是可以改变的字段关联
                    $tableName=$adb->query_result($result,0,'tablename');
                     $columnName=$adb->query_result($result,0,'columnname');
                }
                if(in_array($tableName,$cur_focus->tab_name))
                {
                    $sql='update ld_field set fieldlabel=? where tabid=? and columnname=?';
                    $adb->pquery($sql,array($_REQUEST['zh_fieldlabel'],$tabid,$columnName));
                    $sql="update ld_tranlabel INNER JOIN ld_field
                            on ld_field.fieldid=ld_tranlabel.relateid
                            and ld_tranlabel.trantable='ld_field'
                            set ld_tranlabel.fieldlabel=? 
                            where  ld_tranlabel.tabid=? and ld_field.tabid=? and ld_field.columnname=? and languagetype=?";
              
                    $adb->pquery($sql,array( $_REQUEST['zh_fieldlabel'],$tabid,$tabid,$columnName,'zh'));
                    $adb->pquery($sql,array( $_REQUEST['en_fieldlabel'],$tabid,$tabid,$columnName,'en'));
                     unsetCacheDirectory('fields');
                }
				if(($isedit == 1 || $isedit == 2) && $edit_permission == 3){
					$isedit = 3;
					$savedatabase = 'yes';
				}
                //zkt 20220623 1000143  采购订单、收付款单、出入库单，分录明细增加“合同订单”字段（咏睿）
                //引用字段
				if($before_selectFieldType == 101){
					$cur_module = getTabname($tabid);
					//源单，关联字段
					if(!empty($_REQUEST['related_optionmodule_field'])){
						$fromvalue_info_array = array();
						$query = "select fromvalue_info from ld_related_detailfield where modulename = ? and effect_columnname = ? limit 1";
						$result = $adb->pquery($query,array($cur_module,$columnName));
						$num_rows = $adb->num_rows($result);
						if($num_rows >= 1){
							$fromvalue_info = $adb->query_result($result,0,'fromvalue_info');
							$fromvalue_info_array = ldcrm_json_decode(decode_html($fromvalue_info));
						}
						$related_optionmodule_fields = ldcrm_json_decode($_REQUEST['related_optionmodule_field']);
						foreach($related_optionmodule_fields as $optionmodule => $optionmodule_column){
							$fromvalue_info_array[] = array('module'=>$optionmodule,'column'=>$optionmodule_column,'columntype'=>$optionmodule_column['columntype']);
						}
						$query = "update ld_related_detailfield set fromvalue_info = ? where modulename = ? and effect_columnname = ?";
						$adb->pquery($query,array(ldcrm_json_encode($fromvalue_info_array),$cur_module,$columnName));
					}
				}
               
				//1 是系统非预置字段
                if(!empty($defaultcolumn) && $defaultcolumn != 1){
                   
                    $query = 'update ld_producttoolfield set fieldlabel = ?,defaultvalue=?,presence=?,typeofdata=?,width=?,edit_permission=?,fieldid=?,columnname=?,fieldplaceholder=?,fieldvaluecolor=?,effectivecondition = ? where producttoolfieldid = ?';
                    $adb->pquery($query,array($zh_fieldlabel,$defaultvalue,$ispresence,$uichekdata,$width,$isedit,$fieldid,$columnName,$fieldplaceholder,$fieldvaluecolor,$column_highsearch_info_json,$producttoolfieldid));
                }else{
                    //37282: 单据分录定制修改采购订单的原单类型字段保存后uitype变为1
                    $query = 'update ld_producttoolfield set fieldlabel = ?,defaultvalue=?,presence=?,typeofdata=?,width=?,edit_permission=?,fieldid=?,columnname=?,tablename=?,input_type=?,referencemodule = ?,datarange = ?,approve_demand = ?,maxrowsshow = ?,savedatabase = ?,fieldplaceholder=?,fieldvaluecolor=?,effectivecondition = ? where producttoolfieldid = ?';
                    $adb->pquery($query,array($zh_fieldlabel,$defaultvalue,$ispresence,$uichekdata,$width,$isedit,$fieldid,$columnName,$tableName,$inputModeType,$referencemodule,$datarange,$approve_demand,$maxrowsshow,$savedatabase,$fieldplaceholder,$fieldvaluecolor,$column_highsearch_info_json,$producttoolfieldid));
                }
				//分录字段  -  适用范围
				if($_REQUEST['profile_field_type'] != 0){
					$profile_field_type = $_REQUEST['profile_field_type'];
					$profile_field_value = '';
                    $profilefieldtype='';
					if($profile_field_type == 1){
						$profile_field_value = $_REQUEST['profile_field_value'];
                        $profilefieldtype='user';
					}
                    else if($profile_field_type==3)
                    {
                        $profilefieldtype='role';
                        $profile_field_value = $_REQUEST['profile_field_value'];
                    }
                    else if($profile_field_type==2)
                    {
                        $profilefieldtype='group';
                        $profile_field_value = $_REQUEST['profile_field_value'];
                    }
					if($_REQUEST['profile_field_type'] != 0){
						$cur_module = getTabname($tabid);
						$this->UpdateProductProfile($cur_module,$producttoolfieldid,$profile_field_value,$profilefieldtype);
					}
				}
                $tranlabel_query = 'update ld_tranlabel set fieldlabel = ? where trantable = ? and tabid = ? and relateid = ? and languagetype = ?';
                $adb->pquery($tranlabel_query,array($zh_fieldlabel,'ld_producttoolfield',$tabid,$producttoolfieldid,'zh'));
                $adb->pquery($tranlabel_query,array($en_fieldlabel,'ld_producttoolfield',$tabid,$producttoolfieldid,'en'));
               
				if($type == 'date' || $type == 'datetime' || $type == 'time'){
					$query = 'select columnname,tablename from ld_producttoolfield where producttoolfieldid = ? limit 1';
					$result = $adb->pquery($query,array($producttoolfieldid));
					$columnname = $adb->query_result($result,0,'columnname');
					$tablename = $adb->query_result($result,0,'tablename');
					$adb->pquery("alter table $tablename modify column $columnname $type",array());
				}
				//文本- 修改字段长度
				if($uitype == 1 && $before_selectFieldType != 101){
					$adb->pquery("alter table $tableName modify column $columnName varchar($fldlength)",array());
				}
                if($selectFieldType >=51 && $selectFieldType <=54){
                    $query = 'update ld_producttoolfield set uitype=? where producttoolfieldid = ?';
                    $adb->pquery($query,array($selectFieldType,$producttoolfieldid));
                }
               
                if($inputModeType == 2){//预置字段公式不用重新保存
                    $sql='delete from ld_producttoolfield_formula  where producttoolfieldid=?  ';
                    $adb->pquery($sql,array($producttoolfieldid));
                     if(!empty($columnstring)&&!empty($formulastring))
                    {
                         $sql='select max(sequence) from  ld_producttoolfield_formula  where producttoolfieldid in(select producttoolfieldid from ld_producttoolfield where tabid=?) ';
                        $max_result_sequence=$adb->pquery($sql,array($tabid));
                        if($adb->num_rows($max_result_sequence)>0)
                            $max_sequence=$adb->query_result($max_result_sequence,0,0)+1;
                        else
                            $max_sequence=1;
                        $sql=' insert ld_producttoolfield_formula(formulastring,columnstring,producttoolfieldid,sequence)value(?,?,?,?)';
                        $param=array($formulastring,$columnstring,$producttoolfieldid,$max_sequence);
                        $adb->pquery($sql,$param);
                    }
                    else {
                        $sql=' update ld_producttoolfield set input_type=0 where producttoolfieldid=?';
                        $adb->pquery($sql,array($producttoolfieldid));   
                    }
                }
               
                if($columnName=='discount_percent')
                {
                    
                    
                    $sql="UPDATE ld_producttoolfield a
                                LEFT JOIN ld_producttoolfield_formula b ON a.producttoolfieldid=b.producttoolfieldid
                                SET b.formulastring='base_tax_amount*a',columnstring=\"{formulavar:[{'lettervar':'a','column':'quantity'},base_tax_amount]}\"
                                WHERE 1=1
                                	AND columnname='tax_amount'
                                	AND b.formulastring='base_tax_amount*a*c/100'
                                	AND b.columnstring=\"{formulavar:[{'lettervar':'a','column':'quantity'},base_tax_amount,{'lettervar':'c','column':'discount_percent'}]}\"
                                    and a.tabid=?
                                	AND EXISTS (SELECT 1 FROM ld_producttoolfield WHERE tabid=a.tabid AND presence=1 AND columnname='discount_percent');";
                     $adb->pquery($sql,array($tabid));
                    
                     $sql="UPDATE ld_producttoolfield a
                                LEFT JOIN ld_producttoolfield_formula b ON a.producttoolfieldid=b.producttoolfieldid
                                SET b.formulastring='base_tax_amount*a*c/100',b.columnstring=\"{formulavar:[{'lettervar':'a','column':'quantity'},base_tax_amount,{'lettervar':'c','column':'discount_percent'}]}\"
                                WHERE 1=1
                                	AND columnname='tax_amount'
                                	AND b.formulastring='base_tax_amount*a'
                                	AND b.columnstring=\"{formulavar:[{'lettervar':'a','column':'quantity'},base_tax_amount]}\"
                                    and a.tabid=?
                                	AND EXISTS (SELECT 1 FROM ld_producttoolfield WHERE tabid=a.tabid AND presence<>1 AND columnname='discount_percent');";
                    $adb->pquery($sql,array($tabid));
                }
                //edit:can 20200728 42139: （61mis.com/kfbcrm）系统设置>单据分录定制>合同订单模块>“下拉框”字段编辑界面：在单据分录定制中修改下拉框字段的值，点击保存没有生效，在新增、编辑界面是正常的。（需要补丁）
				if($_REQUEST['uitype'] == 60 || $_REQUEST['uitype'] == 63){
					$objPickList = crm_load_class_obj("cls_PickList",'modules/PickList',array());
					$objPickList->delPickField($columnName,'ld_producttoolfield');
					$objPickList->addPickField($fldPickList,$columnName,'ld_producttoolfield');
				}
            }
            unsetCacheDirectory('productfields');
        }
       
        if($bigtype == 'relatedmodulefield'&&$_REQUEST['savedatabase']=='yes'&&!empty($_REQUEST['related_module_field'])){
                
                
                //引用字段
                $relatemodule=$_REQUEST['related_module'];//引用的模块
                $related_module_field=$_REQUEST['related_module_field'];//引用的模块字段
                //$related_module_column=$_REQUEST['related_module_column'];//触发 字段
                $sql='select trigger_columnname from ld_related_detailfield where modulename=? and effect_columnname=?';
                $tmpresult=$adb->pquery($sql,array($cur_module,$columnName));
                
                $trigger_columnname=$adb->query_result($tmpresult,0,'trigger_columnname');
              
                $relatefocus=CRMEntity::getInstance($relatemodule);
             
                $related_module_fieldinfo=$relatefocus->fieldobj->getFieldInfoobjBykey("columnname",$related_module_field);//
               
                if($related_module_fieldinfo)
                {
                  
                    $cur_focus=CRMEntity::getInstance($cur_module);
                      $Detail_table= $cur_focus->Detail_table;
                      $Detail_table_id=$cur_focus->Detail_table_id;
                      
                    $relatemodule_tablename=$related_module_fieldinfo->getTableName();
                    $relatemodule_tableindex=$relatefocus->table_index;
                    $sql='  set @disable_triggers="aa"';
                    $adb->pquery($sql,array());
                    //修改历史数据
                    $updatesql= " update $tableName  inner join
                    
                    $Detail_table on   $Detail_table.$Detail_table_id=$tableName.$Detail_table_id
                    inner join  $relatemodule_tablename 
                    on $Detail_table.$trigger_columnname=$relatemodule_tablename.$relatemodule_tableindex
                     set $columnName=$relatemodule_tablename.$related_module_field
                     where ifnull($columnName,'')=''";
                       
                     $adb->pquery($updatesql,array());
                     
                     
                }
                 
                
        }
    }



    /**
     * V6.1 单据分录自定义 :更改产品自定义显示列顺序
     * @param producttoolfieldid：当前产品自定义记录ID tabid：当前选中模块ID
     * @author Chj 2015/5/28
     */
    public function UpdateFieldSequence() {
        global $adb;
        $producttoolfieldid = vtlib_purify($_REQUEST['producttoolfieldid']);
        $tabid = vtlib_purify($_REQUEST['tabid']);

        $sequence = vtlib_purify($_REQUEST['sequence']);
        $type = vtlib_purify($_REQUEST['type']);
        if($producttoolfieldid > 0 && $tabid > 0){
            if($type == 'down'){
                $query = 'select producttoolfieldid,sequence from ld_producttoolfield where sequence > ? and tabid = ? order by sequence asc,producttoolfieldid asc limit 0,1';
                $result = $adb->pquery($query,array($sequence,$tabid));
                $next_producttoolfieldid = $adb->query_result($result,0,'producttoolfieldid');
                $next_sequence = $adb->query_result($result,0,'sequence');
            }
            else if($type =='up'){
                $query = 'select producttoolfieldid,sequence from ld_producttoolfield where sequence < ? and tabid = ? order by sequence desc,producttoolfieldid desc limit 0,1';
                //$query = 'select producttoolfieldid,sequence from ld_producttoolfield where sequence < ? and tabid = ? order by sequence desc ,producttoolfieldid desc limit 0,1';
                $result = $adb->pquery($query,array($sequence,$tabid));
                $next_producttoolfieldid = $adb->query_result($result,0,'producttoolfieldid');
                $next_sequence = $adb->query_result($result,0,'sequence');
            }
            $adb->pquery('update ld_producttoolfield set sequence = ? where tabid = ? and producttoolfieldid = ?',array($next_sequence,$tabid,$producttoolfieldid));
            $adb->pquery('update ld_producttoolfield set sequence = ? where tabid = ? and producttoolfieldid = ?',array($sequence,$tabid,$next_producttoolfieldid));
        }
        unsetCacheDirectory('productfields');
    }
	/**
	 * 分录字段 - 字段权限控制
	 * @param	$module 当前设置模块  $producttoolfieldid 分录字段的ID   $useridall 适用范围的用户权限
	 * @return
	 * @author Chj
	 */
    public function UpdateProductProfile($module,$producttoolfieldid,$useridall,$profilefieldtype){
        global $adb;
        $tabid = getTabid($module);
        //删除原有的自定义字段权限
        $adb->pquery('delete from ld_producttoolprofile where producttoolfieldid = ?',array($producttoolfieldid));
        //清除原有的自定义字段权限缓存
        $cachekey = 'getProductProfile_'.$producttoolfieldid.'_'.$tabid;
        unsetCache($cachekey);
       
        if(isset($useridall) && !empty($useridall)){
            $userArr = explode(',',$useridall);
            for($i = 0; $i<count($userArr); $i++){
                if(isset($userArr[$i]) > 0){
                    $query = 'insert into ld_producttoolprofile(producttoolfieldid,tabid,userid,presence,profilefieldtype) values (?,?,?,?,?)';
                    $adb->pquery($query,array($producttoolfieldid,$tabid,$userArr[$i],1,$profilefieldtype));
                    $userall[$i]=$userArr[$i];
                }
            }
            $productprofile[$tabid][$producttoolfieldid] = $userall;
            Cache($cachekey,$productprofile);
            $cachekey = 'getModuleProductToolField'.$tabid;
            unsetCache($cachekey);
        }
    }
//更新、保存自定义字段排序
    public function UpdateFieldSort(){
        global $adb;
        if(!empty($_REQUEST['selectedFieldStr'])){
            $selectedfields = explode(';',$_REQUEST['selectedFieldStr']);
            for($i=0 ;$i<count($selectedfields);$i++){
                if(!empty($selectedfields[$i])){
                    $icolumnsql = "update ld_producttoolfield set sequence=? where producttoolfieldid=? and tabid = ?";
                    $icolumnsqlresult = $adb->pquery($icolumnsql, array(($i+1), $selectedfields[$i], $_REQUEST['tabid']));
                }
            }
        }
    }
//显示自定义隐藏字段
    public function UpdateFieldDis(){
        global $adb;
        if(!empty($_REQUEST['tabid'])){
            //获取当前模块已显示字段的最大顺序值
            $query = 'select max(sequence) as sequence from ld_producttoolfield where tabid = ? and presence in (0,2)';
            $result = $adb->pquery($query,array($_REQUEST['tabid']));
            $max_sequence = $adb->query_result($result,0,0);
            if(!empty($_REQUEST['selectedFieldStr'])){
                $selectedfields = explode(';',$_REQUEST['selectedFieldStr']);
                for($i=0 ;$i<count($selectedfields);$i++){
                    if(!empty($selectedfields[$i])){
                        $icolumnsql = "update ld_producttoolfield set presence=?,sequence=? where producttoolfieldid=? and tabid = ?";
                        $icolumnsqlresult = $adb->pquery($icolumnsql, array(0,($max_sequence+$i+1), $selectedfields[$i], $_REQUEST['tabid']));
                    }
                }
                
                $sql="UPDATE ld_producttoolfield a
                        LEFT JOIN ld_producttoolfield_formula b ON a.producttoolfieldid=b.producttoolfieldid
                        SET b.formulastring='base_tax_amount*a',columnstring=\"{formulavar:[{'lettervar':'a','column':'quantity'},base_tax_amount]}\"
                        WHERE 1=1
                        	AND columnname='tax_amount'
                        	AND b.formulastring='base_tax_amount*a*c/100'
                        	AND b.columnstring=\"{formulavar:[{'lettervar':'a','column':'quantity'},base_tax_amount,{'lettervar':'c','column':'discount_percent'}]}\"
                        	AND EXISTS (SELECT 1 FROM ld_producttoolfield WHERE tabid=a.tabid AND presence<>1 AND columnname='discount_percent' and tabid=?);
                        	";
                    $adb->pquery($sql,array($_REQUEST['tabid']));
            }
        }
    }

}


